"""notebooksalamode.Dataset"""

import os.path
import pandas as pd

class Dataset(object):
    """Represets a Mode dataset"""

    data = None
    error = None
    name = None
    token = None
    file_type = None

    def __init__(self, name, token, path=None, df=None, file_type="json"):
        self.name = name
        self.token = token
        self.error = None
        self.file_type = file_type

        if path is not None:
            self.path = path
            self.load()
            return

        if df is not None:
            self._data = df

    def load_json(self):
        self.data = pd.read_json(self.path, orient='records')
        self.error = False

    def load_csv(self):
        self.data = pd.read_csv(self.path, encoding='utf8')
        self.error = False

    def load(self):
        """Populates a Pandas dataframe for this Dataset"""
        if os.path.isfile(self.path):
            stat = os.path.getsize(self.path)
            if stat > 0:
                if self.file_type == 'json':
                    return self.load_json()
                elif self.file_type == 'csv':
                    return self.load_csv()

        self.data = pd.DataFrame({
            'Error Message' : ["Looks like something went wrong with your query"]
        })
        self.error = True
